use strict;

package TemplateParser;

#####################################################
#													#
#													#
#####################################################
sub new
{ 
	my $class = shift;
	my $self = shift || {};
	bless( $self, $class );
	return $self; 
}

#####################################################
#													#
#													#
#####################################################
sub SetTemplateFile
{
	my $self = shift;
	$self->{ '_template_filename' } = shift @_;
}

#####################################################
#													#
#													#
#####################################################
sub Replace
{
	my $self = shift;
	my $string_to_replace = shift;
	my $replacement_string = shift;

	$self->{ '_replacement_strings' }->{ $string_to_replace } = $replacement_string;
	# print "$string_to_replace => " . $self->{ '_replacement_strings' }->{ $string_to_replace } . "\n";
}

#####################################################
#													#
#													#
#####################################################
sub Parse
{
	my $self = shift;

	open( INPUT, $self->{ '_template_filename' } );
	my $input = join( '', <INPUT> );
	close( INPUT );

	foreach my $key ( keys %{$self->{ '_replacement_strings' }} )
	{
		my $value = $self->{ '_replacement_strings' }->{ $key };
		$input =~ s|\<$key\>|$value|gis;
	}
	return $input;
}

1;

